/* AIFF  COMM  SNDD chunk ΤߤФġ
 * 10/28 2000
 * shige
 * aiffdiet.c
 *
 * $Id: aiffdiet.c,v 1.5 2017-03-09 16:50:43+09 shige Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aiffio.h"

/*####### prototype #######*/
int main(int argc, char *argv[]);
void putchunklist(FILE *outf, Chunk *ch, int chunks);
int getarg(int argc, char *argv[], int *Verbose, FILE **Infile,
	   FILE **Outfile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile;
    int ret, verbose = 0, errret = 10;
    AIFFdata ad;
    Chunk ch[Maxchunks];

    if ((ret = getarg(argc, argv, &verbose, &infile, &outfile)) < 0) {
	if (verbose) fprintf(stderr, "getarg() error.\n");
	usage(-ret); return -ret;
    }
    if ((ret = getAIFFheaderchunk(infile, &ad, ch, 1)) < 0) {
	if (verbose)
	  fprintf(stderr, "getAIFFinfo() error (%d).\n", ret);
	return ++errret;
    } else if (verbose) {
	fseek(infile, 0L, SEEK_END);
	fprintf(stderr, "AIFF: %ld byte\n", ftell(infile));
	fprintf(stderr, " channels      : %d\n", ad.channel);
	fprintf(stderr, " bit/sample    : %d\n", ad.bitpersmpl);
	fprintf(stderr, " flamesize     : %d\n", ad.flamesize);
	fprintf(stderr, " sampling rate : %f\n", ad.smplrate.x);
	fprintf(stderr, " flames    : %ld\n", ad.flames);
	fprintf(stderr, " data size : %ld\n", ad.datalen);
	putchunklist(stderr, ch, ret);
    }

    /* ##### put out ##### */
    putAIFFheader(outfile, &ad);
    putfile2file(infile, outfile, ad.hlen, ad.datalen);
    if (ad.datalen%2) fputc(0, outfile);

    if (verbose)
      fprintf(stderr, "NEW file size : %ld\n", 12 + 8 + 18 + 8 + 8
	      + ad.datalen + ((ad.datalen%2) ? 1 : 0));
    return 0;
}

/* from aufinfo.c */
void putchunklist(FILE *outf, Chunk *ch, int chunks)
{
    int j;
    Chunk *p;

    fprintf(outf, "  chunks :\n");
    for (j=0; j<chunks; j++) {
	p = &(ch[j]);
	fprintf(outf, "  [%d] \"%c%c%c%c\" (size: %ld, start: %ld)\n",
		j + 1, (p->id)[0], (p->id)[1], (p->id)[2], (p->id)[3],
		p->size, p->start);
    }
}

int getarg(int argc, char *argv[], int *Verbose, FILE **Infile,
	   FILE **Outfile)
{
    int j, inoption;
    char c;

    *Verbose = 0;
    *Outfile = stdout;
    
    if (argc < 2) return -1;
    j = 1;
    if (*argv[j] == '-') {
	c = *(++argv[j]);
	while (1) {
	    switch (c) {
	    case 'v': *Verbose = 1; inoption = 1; break;
	    case 'q': *Verbose = 0; inoption = 1; break;
	    case 'o':
		if (*Outfile != stdout) return -2;
		if (*++argv[j] == '\0' && ++j >= argc) return -3;
		if (strcmp(argv[j], "-") == 0) *Outfile = stdout;
		else if ((*Outfile = fopen(argv[j], "w")) == NULL)
		  return -4;
		inoption = 0;
		break;
	    case '\0':
#ifdef STDINSUPPORT
		if (j != argc - 1) return -5;
		*Infile = stdin;
		return 0;
#else
		return -5;
#endif
	    default: return -6;
	    }
	    if (inoption && (c = *(++argv[j])) != '\0') continue;
	    if (++j >= argc) return -7;
	    if (*argv[j] != '-') break;
	    c = *(++argv[j]);
	}
    }
    if (j != argc - 1) return -8;
    if ((*Infile = fopen(argv[j], "r")) == NULL) return -9;
    return 0;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: aiffdiet (-v) (-q) (-o [outfile]) [infile]",
	"   -v : Ĺ⡼",
	"   -q : quiet ⡼ (default)",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [infile]: ϥե",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	"     ϥե '-' ϸߤϥݡȤƤʤ",
	NULL
    };
    int j;

    for (j=0; mess[j]!=NULL; j++)
      fprintf(stderr, "%s\n", mess[j]);
}

