/* AIFF file ôʬ
 * shige
 * 10/29 2000
 * aiffio.c
 *
 * $Id: aiffio.c,v 1.16 2017-03-28 19:53:47+09 shige Exp $
 */
#ifndef __AIFFIO_C__
#define __AIFFIO_C__

#include "aiffio.h"

/* aiff file  header, chunk μ
 * λϥǡƬ
 * mode = 0: fseek  (chunk list Ϻʤ)
 * mode = 1: mode = 0 + chunk list 
 * mode = 5: myfseek  (stdin ) (chunk list Ϻʤ)
 * mode = 6: mode = 1 Ƭ 4 ХȤμ򤷤ʤ
*/
int getAIFFheaderchunk(FILE *file, AIFFdata *ad, Chunk *Ch, int mode)
{
    long int j;
    long int fsize, csize, curpos, dpos = 0L;
    Chunk *ch1;
    int pass = 0;
    int chunks = 0;

    if (mode == 0 || mode == 1) fseek(file, 0, SEEK_SET);
    if (mode != 6) {
    /* magic */
	if (read4bytetoi(file, &j) < 0 || j != sto4bytei("FORM"))
	  return Err_readaiffheader;
    }
    if (read4bytetoi(file, &fsize) < 0 || fsize < 8)
      return Err_readaiffheader;
    fsize += 8;
    if (read4bytetoi(file, &j) < 0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    curpos = 12L;
    /* chunk θ */
    while (1) {
	if ((mode != 1 && pass >= 2) || curpos > fsize - 8L) break;
	if (mode == 1) { /* chunk list  */
	    if (++ chunks > Maxchunks) return Err_too_many_chunks;
	    ch1 = &(Ch[chunks - 1]);
	    ch1->start = curpos;
	    if (fread(ch1->id, 4, 1, file) < 1 
		|| read4bytetoi(file, &(ch1->size)) < 0)
	      return Err_readaiffheader;
	    csize = ch1->size;
	} else { /* chunk list  */
	    if (read4bytetoi(file, &j) < 0 
		|| read4bytetoi(file, &csize) < 0)
	      return Err_readaiffheader;	
	}
	curpos += 8L;
	if ((mode == 1 && ! strncmp(ch1->id, "COMM", 4))
	    || (mode != 1 && j == sto4bytei("COMM"))) {
	    /* Common chunk */
	    if (csize != AIFFCOMMCHUNKSIZE
	       || read2bytetoi(file, &(ad->channel)) < 0 
	       || ad->channel < 1
	       || read4bytetoi(file, &(ad->flames)) < 0
	       || read2bytetoi(file, &(ad->bitpersmpl)) < 0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file, &(ad->smplrate)) < 0)
	      return Err_readaiffheader;
	    else curpos += 8L + IEEEExtendedBytes;
	    ad->flamesize = (ad->channel)*(ad->bitpersmpl)/8;
	    pass ++;
	} else if ((mode == 1 && ! strncmp(ch1->id, "SSND", 4))
	    || (mode != 1 && j == sto4bytei("SSND"))) {
	    /* Sound data chunk */
	    ad->datalen = csize;
	    if (ad->datalen < 8
	       || read4bytetoi(file, &j) < 0 || j != 0
	       || read4bytetoi(file, &j) < 0 || j != 0)
	      return Err_readaiffheader;
	    else curpos += 8L;
	    ad->datalen -= 8;
	    ad->hlen = curpos;
	    if (mode == 1) {
		dpos = curpos;
		fseek(file, ad->datalen + (ad->datalen)%2, SEEK_CUR);
		curpos += ad->datalen + (ad->datalen)%2;
		pass ++;
	    } else {
		if (++ pass != 2) return Err_readaiffheader;
		else break;
	    }

	} else if (csize > 0) {
	    if (mode == 0 || mode == 1)
	      fseek(file, csize + csize%2, SEEK_CUR);
	    else AIFFmyfseek(file, csize + csize%2);
	    curpos += csize + csize%2;
	}
    }
    if (pass < 2) return Err_readaiffheader;
    if (ad->datalen/ad->flamesize != ad->flames)
      return Err_readaiffheader;

    if (mode == 1) {
	fseek(file, dpos, SEEK_SET);
	return chunks;
    }
    else return No_err;
}

#if 0
/* aiff file  header μ */
int getAIFFheader(FILE *file, AIFFdata *ad)
{
    long int j;
    long int size, csize;
    int pass = 0;

    fseek(file, 0, SEEK_SET);
    /* magic */
    if (read4bytetoi(file, &j) < 0 || j != sto4bytei("FORM")
       || read4bytetoi(file, &size) < 0 || size < 8
       || read4bytetoi(file, &j) < 0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size += 8;
    /* chunk θ */
    while (pass < 2) {
	if (ftell(file) > size - 8) break;
	if (read4bytetoi(file, &j) < 0 
	    || read4bytetoi(file, &csize) < 0)
	  return Err_readaiffheader;	
	if (j == sto4bytei("COMM")) { /* Common chunk */
	    if (csize != AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file, &(ad->channel)) < 0 
	       || ad->channel < 1
	       || read4bytetoi(file, &(ad->flames)) < 0
	       || read2bytetoi(file, &(ad->bitpersmpl)) < 0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file, &(ad->smplrate)) < 0)
	      return Err_readaiffheader;
	    ad->flamesize = (ad->channel)*(ad->bitpersmpl)/8;
	    pass ++;
	} else if (j == sto4bytei("SSND")) { /* Sound data chunk */
	    ad->datalen = csize;
	    if (ad->datalen < 8
	       || read4bytetoi(file, &j) < 0 || j != 0
	       || read4bytetoi(file, &j) < 0 || j != 0)
	      return Err_readaiffheader;
	    ad->datalen -= 8;
	    ad->hlen = ftell(file);
	    /* fseek(file, ad->datalen, SEEK_CUR); */
	    if (++pass != 2) return Err_readaiffheader;
	    else break;
	} else if (csize > 0) fseek(file, csize, SEEK_CUR);
	/* skip only */
	if (csize%2) fseek(file, 1, SEEK_CUR);
    }
    if (pass < 2) return Err_readaiffheader;
    if (ad->datalen/ad->flamesize != ad->flames)
      return Err_readaiffheader;
    return No_err;
}

/* aiff file  header μ */
int getAIFFheader_noseek(FILE *file, AIFFdata *ad)
{
    long int j;
    long int size, csize, curpos;
    int pass = 0;

    if (read4bytetoi(file, &j) < 0 || j != sto4bytei("FORM")
       || read4bytetoi(file, &size) < 0 || size < 8
       || read4bytetoi(file, &j) < 0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size += 8;
    curpos = 12L;
    /* chunk θ */
    while (pass < 2) {
	if (curpos > size - 8) break;
	if (read4bytetoi(file, &j) < 0
	    || read4bytetoi(file, &csize) < 0)
	  return Err_readaiffheader;	
	curpos += 8;
	if (j == sto4bytei("COMM")) { /* Common chunk */
	    if (csize != AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file, &(ad->channel)) < 0 
	       || ad->channel < 1
	       || read4bytetoi(file, &(ad->flames)) < 0
	       || read2bytetoi(file, &(ad->bitpersmpl)) < 0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file, &(ad->smplrate)) < 0)
	      return Err_readaiffheader;
	    ad->flamesize = (ad->channel)*(ad->bitpersmpl)/8;
	    curpos += 8 + IEEEExtendedBytes;
	    pass++;
	} else if (j == sto4bytei("SSND")) { /* Sound data chunk */
	    ad->datalen = csize;
	    if (ad->datalen < 8
	       || read4bytetoi(file, &j) < 0 || j != 0
	       || read4bytetoi(file, &j) < 0 || j != 0)
	      return Err_readaiffheader;
	    curpos += 8;
	    ad->datalen -= 8;
	    ad->hlen = curpos;
	    if (++ pass != 2) return Err_readaiffheader;
	    else break;
	} else if (csize > 0) AIFFmyfseek(file, csize + csize%2);
    }
    if (pass < 2) return Err_readaiffheader;
    if (ad->datalen/ad->flamesize != ad->flames) 
      return Err_readaiffheader;
    return No_err;
}

/* getAIFFheader_noseek() Ρǽ 4 byte ɤޤ줿Ȥ
 */
int getAIFFheader_noseek2(FILE *file, AIFFdata *ad)
{
    long int j;
    long int size, csize, curpos;
    int pass = 0;

    if (read4bytetoi(file, &size) < 0 || size < 8
       || read4bytetoi(file, &j) < 0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size += 8;
    curpos = 12L;
    /* chunk θ */
    while (pass < 2) {
	if (curpos > size - 8) break;
	if (read4bytetoi(file, &j) < 0
	    || read4bytetoi(file, &csize) < 0)
	  return Err_readaiffheader;	
	curpos += 8;
	if (j == sto4bytei("COMM")) { /* Common chunk */
	    if (csize != AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file, &(ad->channel)) < 0 
	       || ad->channel < 1
	       || read4bytetoi(file, &(ad->flames)) < 0
	       || read2bytetoi(file, &(ad->bitpersmpl)) < 0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file, &(ad->smplrate)) < 0)
	      return Err_readaiffheader;
	    ad->flamesize = (ad->channel)*(ad->bitpersmpl)/8;
	    curpos += 8 + IEEEExtendedBytes;
	    pass++;
	} else if (j == sto4bytei("SSND")) { /* Sound data chunk */
	    ad->datalen = csize;
	    if (ad->datalen < 8
	       || read4bytetoi(file, &j) < 0 || j != 0
	       || read4bytetoi(file, &j) < 0 || j != 0)
	      return Err_readaiffheader;
	    curpos += 8;
	    ad->datalen -= 8;
	    ad->hlen = curpos;
	    if (++pass != 2) return Err_readaiffheader;
	    else break;
	} else if (csize > 0) AIFFmyfseek(file, csize + csize%2);
    }
    if (pass < 2) return Err_readaiffheader;
    if (ad->datalen/ad->flamesize != ad->flames)
      return Err_readaiffheader;
    return No_err;
}
#endif

void AIFFmyfseek(FILE *file, int num)
{
    int j;

    for (j=1; j<=num; j++) fgetc(file);
}

#if 0
/* aiff file  header μ & chunk list κ */
int getAIFFinfo(FILE *file, AIFFdata *ad, Chunk *Ch)
{
    long int j;
    long int size;
    int pass = 0;
    Chunk *ch;
    int chunks = 0;

    fseek(file, 0, SEEK_SET);
    /* magic */
    if (read4bytetoi(file, &j) < 0 || j != sto4bytei("FORM")
       || read4bytetoi(file, &size) < 0 || size < 8
       || read4bytetoi(file, &j) < 0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size += 8;
    /* chunk θ */
    while (1) {
	if (ftell(file) > size - 8) break;
	if (++ chunks > Maxchunks) return Err_too_many_chunks;
	ch = &(Ch[chunks - 1]);
	ch->start = ftell(file);
	if (fread(ch->id, 4, 1, file) < 1 
	    || read4bytetoi(file, &(ch->size)) < 0)
	  return Err_readaiffheader;
	if (strncmp(ch->id, "COMM", 4) == 0) { /* Common chunk */
	    if (ch->size != AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file, &(ad->channel)) < 0 
	       || ad->channel < 1
	       || read4bytetoi(file, &(ad->flames)) < 0
	       || read2bytetoi(file, &(ad->bitpersmpl)) < 0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file, &(ad->smplrate)) < 0)
	      return Err_readaiffheader;
	    ad->flamesize = (ad->channel)*(ad->bitpersmpl)/8;
	    pass++;
	} else if (strncmp(ch->id, "SSND", 4) == 0) {
	    /* Sound data chunk */
	    ad->datalen = ch->size;
	    if (ad->datalen < 8
	       || read4bytetoi(file, &j) < 0 || j != 0
	       || read4bytetoi(file, &j) < 0 || j != 0)
	      return Err_readaiffheader;
	    ad->datalen -= 8;
	    ad->hlen = ftell(file);
	    fseek(file, ad->datalen, SEEK_CUR);	
	    pass++;
	} else if (ch->size > 0) fseek(file, ch->size, SEEK_CUR);
	/* skip only */
	if ((ch->size)%2) fseek(file, 1, SEEK_CUR);
    }
    if (pass < 2) return Err_readaiffheader;
    if (ad->datalen/ad->flamesize != ad->flames)
      return Err_readaiffheader;
    return chunks;
}
#endif

/* AIFF header  */
int chAIFFheader(AIFFdata *ad1, AIFFdata *ad2)
{
    if (ad1->channel != ad2->channel) return Err_diffchannel;
    if (ad1->bitpersmpl != ad2->bitpersmpl) return Err_diffbitpersmpl;
    if (chAIFFExtended(&(ad1->smplrate), &(ad2->smplrate)))
      return Err_diffsmplrate;
    if (ad1->flamesize != ad2->flamesize) return Err_diffblocksize;
    return No_err;
}

int chAIFFheaderMASK(AIFFdata *ad1, AIFFdata *ad2, int mask)
{
    if (mask&AIFF_CHANNEL && ad1->channel != ad2->channel) 
      return Err_diffchannel;
    if (mask&AIFF_BITPERSMPL && ad1->bitpersmpl != ad2->bitpersmpl) 
      return Err_diffbitpersmpl;
    if (mask&AIFF_SMPLRATE 
	&& chAIFFExtended(&(ad1->smplrate), &(ad2->smplrate)))
      return Err_diffsmplrate;
    if (mask&AIFF_FLAMESIZE && ad1->flamesize != ad2->flamesize) 
      return Err_diffblocksize;
    return No_err;
}

/* header ν */
void putAIFFheader(FILE *file, AIFFdata *ad)
{
    long int datalen;

    writeito4byte(file, sto4bytei("FORM"));
    if (0) {
	datalen = (ad->flames)*(ad->flamesize);
	if (datalen%2) datalen ++;
    } else datalen = ad->datalen;
    writeito4byte(file, 4 + 8 + AIFFCOMMCHUNKSIZE + 8 + 8 + datalen);
    writeito4byte(file, sto4bytei("AIFF"));
    /* COMM chunk */
    writeito4byte(file, sto4bytei("COMM"));
    writeito4byte(file, AIFFCOMMCHUNKSIZE);
    writeito2byte(file, ad->channel);
    writeito4byte(file, ad->flames);
    writeito2byte(file, ad->bitpersmpl);
    writeAIFFExtended(file, &(ad->smplrate));
    /* SSND chunk */
    writeito4byte(file, sto4bytei("SSND"));
    writeito4byte(file, ad->flames*ad->flamesize + 8);
    writeito4byte(file, 0L);
    writeito4byte(file, 0L);
    /*  SSND data Ϥơɬפʤ 1 byte dummy Ĥ */
}

/* ########## for "extended" floating point routine ########## */
/* AIFF  sampling rate  80bit IEEE long double (== extended) */ 
int readAIFFExtended(FILE *file, Extended *Ex)
{
    if (fread(Ex->s, IEEEExtendedBytes, 1, file) < 1)
      return Err_fread;
    Ex->x = ConvertFromIeeeExtended(Ex->s);
    return No_err;
}

int writeAIFFExtended(FILE *file, Extended *Ex)
{
    int j;

    for (j=0; j<IEEEExtendedBytes; j++) fputc(*(Ex->s + j), file);
    return No_err;
}

int chAIFFExtended(Extended *Ex1, Extended *Ex2)
{
    int j;

    for (j=0; j<IEEEExtendedBytes; j++)
      if (*(Ex1->s + j) != *(Ex2->s + j)) return 1;
    return 0;
}

#endif /* __AIFFIO_C__ */
