/* AIFF file ôʬΥإåե
 * shige
 * 10/29 2000
 * aiffio.h
 * 
 * $Id: aiffio.h,v 1.17 2017-03-09 16:50:33+09 shige Exp $
 */
#ifndef __AIFFIO_H__
#define __AIFFIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chunk.h"
#include "error.h"
#include "fileio.h"
#include "ToFromIEEE.h"
#include "cstruct.h"

#ifdef __AIFFIO_C__
# define AIFFCOMMCHUNKSIZE 18
#endif /* __AIFFIO_C__ */

#define IEEEExtendedBytes 10

typedef struct {
    double x;
    char s[IEEEExtendedBytes];
} Extended;

typedef struct {
    short int channel;	/* 1, 2, ..., 6 */
    long int flames;	/* number of blocks = datalen/flamesize */
    short int bitpersmpl;	/* 8, 16, 24, 32 */
    Extended smplrate;	/* frames/sec */
    short int flamesize;	/* channel*bitpersmpl/8 */
    long int hlen;	/* data start offset */
    long int datalen;	/* data size (byte) */
} AIFFdata;

/* ̵ǡ */
#define AIFF8NULL (0xff)
#define AIFF16NULL (0xfff8)
/* AIFFSCALE*bit: |粻|
 * AIFFPOS*bit: linear data shift 
 */
#define AIFFPOS8bit 0
#define AIFFSCALE8bit 125.0
#define AIFFPOS16bit 0
#define AIFFSCALE16bit 32764.0

#define AIFFMAXChannel 50


#define AIFF_CHANNEL	0x0004
#define AIFF_SMPLRATE	0x0008
#define AIFF_FLAMESIZE	0x0010
#define AIFF_BITPERSMPL	0x0020

#define AIFF_BLOCKSIZE AIFF_FLAMESIZE

#ifdef __AIFFIO_C__
# define EXTERN_AIFFIO 
#else
# define EXTERN_AIFFIO extern 
#endif

EXTERN_AIFFIO int getAIFFheaderchunk(FILE *file, AIFFdata *ad,
				     Chunk *Ch, int mode);
#if 0
EXTERN_AIFFIO int getAIFFheader(FILE *file, AIFFdata *ad);
EXTERN_AIFFIO int getAIFFheader_noseek(FILE *file, AIFFdata *ad);
EXTERN_AIFFIO int getAIFFheader_noseek2(FILE *file, AIFFdata *ad);
#endif
EXTERN_AIFFIO void AIFFmyfseek(FILE *file, int num);
#if 0
EXTERN_AIFFIO int getAIFFinfo(FILE *file, AIFFdata *ad, Chunk *Ch);
#endif
EXTERN_AIFFIO int chAIFFheader(AIFFdata *ad1, AIFFdata *ad2);
EXTERN_AIFFIO int chAIFFheaderMASK(AIFFdata *ad1, AIFFdata *ad2,
				   int mask);
EXTERN_AIFFIO void putAIFFheader(FILE *file, AIFFdata *ad);
EXTERN_AIFFIO int readAIFFExtended(FILE *file, Extended *Ex);
EXTERN_AIFFIO int writeAIFFExtended(FILE *file, Extended *Ex);
EXTERN_AIFFIO int chAIFFExtended(Extended *Ex1, Extended *Ex2);

#endif /* __AIFFIO_H__ */
