/* 
 * au,wav,aiff  format ˤʤġѤ subroutine
 * common.c
 * shige
 * 12/27 2003
 * 
 * $Id: common.c,v 1.35 2017-03-28 17:47:41+09 shige Exp $
 */
/* 1)	header μưȽ⤳˴ޤޤ롣
 * 2)	Snddata, WAVdata, AIFFdata ΤȤ뤫
 */
#ifndef __COMMON_C__
#define __COMMON_C__

#include "common.h"

/* format ⤢ٲꤹ롣
 * AU: fmcode=1, smplrate=8000, channel=1
 * WAV: fmcode=1, bitpersmpl=8||16
 * AIFF: bitpersmpl=8||16
 */
int getSNDheader(FILE *file, SNDheader *snd)
{
    char magic[4];

    if (fread(magic, 1, 4, file) != 4) return E_UNKNOWN;
    if (strncmp(magic, ".snd", 4) == 0) {
	if (getAUheader(file, &(snd->au), 6) < 0) return -1;
	(snd->au).magic = sto4bytei(magic);
	if ((snd->au).fmcode != 1 || (snd->au).smplrate != 8000) 
	  return -7;
	else return E_AU;
    } else if (strncmp(magic, "RIFF", 4) == 0) {
	if (getWAVheaderchunk(file, &(snd->wav), NULL, 6) < 0) return -2;
	if ((snd->wav).fmcode != 1) return -8;
	if ((snd->wav).bitpersmpl != 8 && (snd->wav).bitpersmpl != 16)
	  return -5;
	else return E_WAV;
    } else if (strncmp(magic, "FORM", 4) == 0) {
	if (getAIFFheaderchunk(file, &(snd->aiff), NULL, 6) < 0) return -3;
	if ((snd->aiff).bitpersmpl != 8 && (snd->aiff).bitpersmpl != 16)
	  return -6;
	else return E_AIFF;
    } else return -4;
}

int putSNDheader(FILE *file, SNDheader *snd, int format)
{
    switch (format) {
    case E_AU: putAUheader(file, &(snd->au)); return E_AU; 
    case E_WAV:	putWAVheader(file, &(snd->wav)); return E_WAV; 
    case E_AIFF: putAIFFheader(file, &(snd->aiff)); return E_AIFF;
    default: return -1;
    }
}

/* flags ˽ä snd λꤷѥ᡼ѹ롣
 * ̷⤷ͤꤹ֤
 * (ºݤˤǤʤ褦ˤ)
 * CH_MAGIC ʤ顢ޤ⤵ƤʤȤ magic, hlen ꤹ롣
 */
int setSNDheader(SNDheader *snd, int format, int fmcode, int channel, 
		double smplrate, int bitpersmpl, long int blocks, 
		int flags)
{
    switch(format) {
    case E_AU:
	/* magic, hlen, blocksize, bitpersmpl, datalen ѹԲĤȤ롣
	 * ==> CH_MAGIC ξϡmagic, hlen, fmcode ꤹ ()
	 */
	if (flags & CH_MAGIC) {
	    (snd->au).magic = sto4bytei(".snd");
	    (snd->au).hlen = 32;
	    (snd->au).str = NULL;
	    (snd->au).fmcode = 1;
	}
	/* blocks  blocks = datalen/channel Ƿ׻롣
	 */
	if (flags & CH_FMCODE) (snd->au).fmcode = (long int) fmcode;
	if (flags & CH_CHANNEL) (snd->au).channel = (long int) channel;
	if (flags & CH_SMPLRATE)
	  (snd->au).smplrate = (long int) smplrate;
	/* blocks ϺǸˤ */
	if (flags & CH_BLOCKS)
	  (snd->au).datalen = blocks*(snd->au).channel;
	break;
    case E_WAV:
	/* hlen, blocksize, bytepersec, datalen ѹԲĤȤ롣
	 * ==> CH_MAGIC ξϡhlen, fmcode ꤹ ()
	 */
	if (flags & CH_MAGIC) {
	    (snd->wav).hlen = 44;
	    (snd->wav).fmcode = 1;
	}
	/* blocks  blocks = datalen/blocksize Ƿ׻롣
	 * ʲɬפ롣
	 *   blocksize = bitpersmpl * channel / 8
	 *   bytepersec = blocksize * smplrate
	 */
	if (flags & CH_FMCODE) (snd->wav).fmcode = (short int) fmcode;
	if (flags & CH_CHANNEL)
	  (snd->wav).channel = (short int) channel;
	if (flags & CH_SMPLRATE)
	  (snd->wav).smplrate = (long int) smplrate;
	if (flags & CH_BITPERSMPL)
	  (snd->wav).bitpersmpl = (short int) bitpersmpl;

	(snd->wav).blocksize = (short int)((snd->wav).bitpersmpl 
					   *(snd->wav).channel/8);
	(snd->wav).bytepersec = (long int)((snd->wav).blocksize
					   *(snd->wav).smplrate);
	/* blocks ϺǸˤ */
	if (flags & CH_BLOCKS)
	  (snd->wav).datalen = blocks*(snd->wav).blocksize;
	break;
    case E_AIFF:
	/* hlen, fmcode, flamesize, datalen ѹԲĤȤ롣
	 * ==> CH_MAGIC ξϡhlen ꤹ ()
	 */
	if (flags & CH_MAGIC) (snd->aiff).hlen = 44 + IEEEExtendedBytes;
	/* blocks = flames
	 * ʲɬפ롣
	 *   flamesize = bitpersmpl * channel / 8
	 *   flames (blocks) = datalen / flamesize
	 */
	if (flags & CH_CHANNEL)
	  (snd->aiff).channel = (short int) channel;
	if (flags & CH_SMPLRATE) {
	    (snd->aiff).smplrate.x = smplrate;
	    ConvertToIeeeExtended((snd->aiff).smplrate.x,
				  (snd->aiff).smplrate.s);
	}
	if (flags & CH_BITPERSMPL)
	  (snd->aiff).bitpersmpl = (short int) bitpersmpl;

	(snd->aiff).flamesize = (short int) ((snd->aiff).channel
					     *(snd->aiff).bitpersmpl/8);
	/* blocks ϺǸˤ */
	if (flags & CH_BLOCKS) (snd->aiff).flames = blocks;
	(snd->aiff).datalen = (snd->aiff).flames 
	    * (snd->aiff).flamesize;
	break;
    default: return -1;
    }
    return 0;
}

/* ##### common usuable subroutine ##### */
/* volume weight ׻ؿ
 * T > t1 + t2 ȤϲꤷʤT < t1 + t2 ΤȤϾˤ ?
 */
static double volweight(double t, double T, double t1, double t2,
                       double svol, double evol)
{
    double t0;

    if (T <= 0.0 || t < 0.0 || t > T) return 0.0;
    /* T > 0.0 && 0.0 <= t <= T */
    if (t1 < 0.0) t1 = 0.0;
    if (t2 < 0.0) t2 = 0.0;
    if (t >= t1 && t <= T - t2) {
	if (svol == evol) return svol;
	else return svol + (t - t1)*(evol - svol)/(T - t1 - t2);
    }
    /* t < t1 || t > T - t2 */
    if (t1 > 0.0 && t2 > 0.0 && T < t1 + t2) {
       t0 = t1*T/(t1 + t2);
       if (t < t0) return t*svol/t1;
       else return (T - t)*evol/t2;
    }
    /* T >= t1 + t2 || t1 <= 0.0 || t2 <= 0.0 */
    if (t1 > 0.0 && t < t1) return t*svol/t1;
    if (t2 > 0.0 && t > T - t2) return (T - t)*evol/t2;
    return -1.0; /* ʤϤ */
}

/* Ƭ t1 ms ȺǸ t2 ms  0 ˤĤʤ
 */
/* olen = ϥǡ֥å
 * maxilen = infile ֥å
 * return value = ϥǡ֥å
 * times = Ψ (Ѵ)ץ󥰴ֳ֤ times 
 *   (times )
 * svol[] = ʬ volume Ψ (ƥͥ)
 * evol[] = ʬλ volume Ψ (ƥͥ)
 * t1: ǽ t1[ms]  0  svol ˤĤʤ
 * t2: Ǹ t2[ms]  evol  0 ˤĤʤ
 */
int SNDputtrans(FILE *infile, FILE *outfile, SNDheader *snd,
               int format, long int olen, long int maxilen, double times, 
               double t1, double t2, double svol[], double evol[])
{
    double x0[MAXChannel], x1[MAXChannel];
    int ch, k;
    long int inum = 0L, onum = 0L;
    double smpl, tmpt, t, dt, T, x, v;
    
    ch = SNDchannels(snd, format);
    smpl = SNDsmplrate(snd, format);

    dt = 1000.0/smpl;
    t = 0.0;
    if (times <= 0.0 || times == 1.0) { /* times Ѵʤ */
       T = olen*1000/smpl;
       for (onum=0; onum<olen; onum++) {
           for (k=0; k<ch; k++) {
	       v = volweight(t, T, t1, t2, svol[k], evol[k]);
               if (v == 1.0)
		 SNDpass1chrawdata(infile, outfile, snd, format);
	       else {
		   x = SNDget1chleveldata(infile, snd, format);
		   SNDput1chleveldata(outfile, x*v, snd, format);
	       }
           }
           t += dt;
       }
       return olen;
    }
    tmpt = 0.0;
    T = olen*1000/smpl;

    inum ++;
    for (k=0; k<ch; k++) 
      x0[k] = SNDget1chleveldata(infile, snd, format);
    while (1) {
#ifdef DEBUG4
	if (++ inum > maxilen) {
	    fprintf(stderr, "[debug4] (inum, onum, maxilen, olen)");
	    fprintf(stderr, " = (%ld, %ld, %ld, %ld)\n", 
		    inum, onum, maxilen, olen);
	    return -1;
	}
#else
       if (++ inum > maxilen) return -1;
#endif
       for (k=0; k<ch; k++) 
	 x1[k] = SNDget1chleveldata(infile, snd, format);
       while (tmpt <= 1.0) {
           for (k=0; k<ch; k++) {
               x = x0[k]*(1.0 - tmpt) + x1[k]*tmpt;
               v = volweight(t, T, t1, t2, svol[k], evol[k]);
               SNDput1chleveldata(outfile, x*v, snd, format);
           }
           if (++ onum >= olen) return inum;
           tmpt += times;
           t += dt;
       }
       tmpt -= 1.0;
       for (k=0; k<ch; k++) x0[k] = x1[k];
    }
}

void SNDskipheader(FILE *infile, int format)
{
    SNDheader tmp;

    switch (format) {
    case E_AU: 
	getAUheader(infile, &(tmp.au), 0);
	return;
    case E_WAV:
	getWAVheaderchunk(infile, &(tmp.wav), NULL, 0);
	return;
    case E_AIFF:
	getAIFFheaderchunk(infile, &(tmp.aiff), NULL, 0);
	return;
    }
}

void SNDskip1chdata(FILE *infile, SNDheader *snd, int format)
{
    int bps = SNDbitpersmpl(snd, format), k;

    for (k=1; k<=bps/8; k++) fgetc(infile);
}

void SNDpass1chrawdata(FILE *infile, FILE *outfile, SNDheader *snd, 
		       int format)
{
    int c, bps = SNDbitpersmpl(snd, format), k;

    for (k=1; k<=bps/8; k++)
      if ((c = fgetc(infile)) != EOF) fputc(c, outfile);
}

void SNDputnull1ch(FILE *outfile, SNDheader *snd, int format)
{
    switch(format) {
    case E_AU: fputc(AUNULL, outfile); return;
    case E_WAV:
        if ((snd->wav).bitpersmpl == 8) fputc(WAV8NULL, outfile);
        else writelittleito2byte(outfile, WAV16NULL);
        return;
    case E_AIFF:
        if ((snd->aiff).bitpersmpl == 8) fputc(AIFF8NULL, outfile);
        else writeito2byte(outfile, AIFF16NULL);
        return;
    default: return;
    }
}

int SNDput1chleveldata(FILE *outfile, double data, SNDheader *snd, int format)
{
    unsigned char uc;
    char c;
    short int x;

    if (data == 0.0) { SNDputnull1ch(outfile, snd, format); return 0; }
    switch (format) {
    case E_AU: 
	uc = linear2ulaw(data*AUSCALE + 0.5);
	fputc(uc, outfile); return 0;
    case E_WAV:
        if ((snd->wav).bitpersmpl == 8) {
	    uc = data*WAVSCALE8bit + WAVPOS8bit + 0.5;
	    fputc(uc, outfile);
	} else {
	    x = data*WAVSCALE16bit + WAVPOS16bit + 0.5;
	    writelittleito2byte(outfile, x);
	}
        return 0;
    case E_AIFF:
        if ((snd->aiff).bitpersmpl == 8) {
	    c = data*AIFFSCALE8bit + AIFFPOS8bit + 0.5;
	    fputc(c, outfile);
	} else {
	    x = data*AIFFSCALE16bit + AIFFPOS16bit + 0.5;
	    writeito2byte(outfile, x);
	}
        return 0;
    default: return -1;
    }
}

double SNDget1chleveldata(FILE *infile, SNDheader *snd, int format)
{
    short int sx;
    unsigned char ucx;
    char cx;

    switch(format) {
    case E_AU:
	return (double)ulaw2linear(fgetc(infile))/AUSCALE;
    case E_WAV:
	if ((snd->wav).bitpersmpl == 8) {
	    ucx = fgetc(infile);
	    return (double)(ucx - WAVPOS8bit)/WAVSCALE8bit;
	} else {
	    read2bytetolittlei(infile, &sx);
	    return (double)(sx - WAVPOS16bit)/WAVSCALE16bit;
	}
    case E_AIFF:
	if ((snd->aiff).bitpersmpl == 8) {
	    cx = fgetc(infile);
	    return (double)(cx - AIFFPOS8bit)/AIFFSCALE8bit;
	} else {
	    read2bytetoi(infile, &sx);
	    return (double)(sx - AIFFPOS16bit)/AIFFSCALE16bit;
	}
    default: return 0.0;
    }
}

/* ########## إåؿ ########## */
/* set Ϥ putheader ϤĤˤޤȤ
 */
int cpSNDheader(SNDheader *new, SNDheader *org, int format)
{
    int j;

    switch(format) {
    case E_AU:
	(new->au).magic = (org->au).magic;
	(new->au).hlen = (org->au).hlen;
	(new->au).datalen = (org->au).datalen;
	(new->au).fmcode = (org->au).fmcode;
	(new->au).smplrate = (org->au).smplrate;
	(new->au).channel = (org->au).channel;
	(new->au).str = (org->au).str;
	return E_AU;
    case E_WAV:
	(new->wav).fmcode = (org->wav).fmcode;
	(new->wav).channel = (org->wav).channel;
	(new->wav).smplrate = (org->wav).smplrate;
	(new->wav).bytepersec = (org->wav).bytepersec;
	(new->wav).blocksize = (org->wav).blocksize;
	(new->wav).bitpersmpl = (org->wav).bitpersmpl;
	(new->wav).hlen = (org->wav).hlen;
	(new->wav).datalen = (org->wav).datalen;
	return E_WAV;
    case E_AIFF:
	(new->aiff).channel = (org->aiff).channel;
	(new->aiff).flames = (org->aiff).flames;
	(new->aiff).bitpersmpl = (org->aiff).bitpersmpl;
	(new->aiff).smplrate.x = (org->aiff).smplrate.x;
	for (j=0; j<IEEEExtendedBytes; j++) 
	  (new->aiff).smplrate.s[j] = (org->aiff).smplrate.s[j];
	(new->aiff).flamesize = (org->aiff).flamesize;
	(new->aiff).hlen = (org->aiff).hlen;
	(new->aiff).datalen = (org->aiff).datalen;
	return E_AIFF;
    default: return -1;
    }
}

int SNDblocksize(SNDheader *snd, int format)
{
    switch (format) {
    case E_AU: return (snd->au).channel;
    case E_WAV: return (snd->wav).blocksize;
    case E_AIFF: return (snd->aiff).flamesize;
    default: return -1;
    }
}

int SNDbitpersmpl(SNDheader *snd, int format)
{
    switch (format) {
    case E_AU: return 8;
    case E_WAV: return (snd->wav).bitpersmpl;
    case E_AIFF: return (snd->aiff).bitpersmpl;
    default: return -1;
    }
}

int SNDchannels(SNDheader *snd, int format)
{
    switch (format) {
    case E_AU: return (snd->au).channel;
    case E_WAV: return (snd->wav).channel;
    case E_AIFF: return (snd->aiff).channel;
    default: return -1;
    }
}

int SNDchheaderMASK(SNDheader *snd1, SNDheader *snd2, int format,
		    int mask)
{
    switch(format) {
    case E_AU: 
	return chAUheaderMASK(&(snd1->au), &(snd2->au), mask);
    case E_WAV: 
	return chWAVheaderMASK(&(snd1->wav), &(snd2->wav), mask);
    case E_AIFF: 
	return chAIFFheaderMASK(&(snd1->aiff), &(snd2->aiff), mask);
    default: return -20;
    }
}

long int SNDblocks(SNDheader *snd, int format)
{
    switch(format) {
    case E_AU: return (snd->au).datalen/(snd->au).channel;
    case E_WAV: return (snd->wav).datalen/(snd->wav).blocksize;
    case E_AIFF: return (snd->aiff).flames;
    default: return -1;
    }
}

long int SNDdatalen(SNDheader *snd, int format)
{
    /* return SNDblocksize(snd, format)*SNDblocks(snd, format); */
    switch(format) {
    case E_AU: return (snd->au).datalen;
    case E_WAV: return (snd->wav).datalen;
    case E_AIFF: return (snd->aiff).datalen;
    default: return -1;
    }
}

long int SNDhlen(SNDheader *snd, int format)
{
    switch(format) {
    case E_AU: return (snd->au).hlen;
    case E_WAV: return (snd->wav).hlen;
    case E_AIFF: return (snd->aiff).hlen;
    default: return -1;
    }
}

double SNDsmplrate(SNDheader *snd, int format)
{
    switch(format) {
    case E_AU: return (snd->au).smplrate;
    case E_WAV: return (snd->wav).smplrate;
    case E_AIFF: return (snd->aiff).smplrate.x;
    default: return -1;
    }
}

double SNDgetmaxlevel(FILE *infile, SNDheader *snd, int format)
{
    long int blocks, j;
    double x, max;
    int ch;

    if (format != E_AU && format != E_WAV && format != E_AIFF) 
      return -1.0;
    blocks = SNDblocks(snd, format);
    ch = SNDchannels(snd, format);

    if (blocks*ch < 1) return -1.0;
    x = SNDget1chleveldata(infile, snd, format);
    max = Abs(x);
    for (j=2; j<=blocks*ch; j++) {
	x = SNDget1chleveldata(infile, snd, format);
	if (Abs(x) > max) max = Abs(x);
    }
    return max;
}

/* maxlevel[]  channel Ȥ뤳Ȥ򤢤餫 check 
 */ 
double SNDgetmaxlevelChannel(FILE *infile, SNDheader *snd, int format,
			     double maxlevel[])
{
    long int blocks, j;
    double x, max = -1.0;
    int ch, k;

    if (format != E_AU && format != E_WAV && format != E_AIFF)
      return -1.0;
    blocks = SNDblocks(snd, format);
    ch = SNDchannels(snd, format);

    if (blocks*ch < 1) return -1.0;
    
    for (k=0; k<ch; k++) {
	x = SNDget1chleveldata(infile, snd, format);
	maxlevel[k] = Abs(x);
	if (maxlevel[k] > max) max = maxlevel[k];
    }
    for (j=2; j<=blocks; j++)
      for (k=0; k<ch; k++) {
	  x = SNDget1chleveldata(infile, snd, format);
	  if (Abs(x) > maxlevel[k]) maxlevel[k] = Abs(x);
	  if (maxlevel[k] > max) max = maxlevel[k];
      }
    return max;
}

#endif /* __COMMON_C__ */
