/* WAV file ôʬΥإåե
 * shige
 * 10/01 2000
 * wavio.h
 * 
 * $Id: wavio.h,v 1.15 2017-03-09 16:07:39+09 shige Exp $
 */
#ifndef __WAVIO_H__
#define __WAVIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chunk.h"
#include "error.h"
#include "fileio.h"
#include "cstruct.h"

typedef struct {
    short int fmcode;
    short int channel;
    long int smplrate;
    long int bytepersec;
    short int blocksize;
    short int bitpersmpl;
    /* short int extendedsize; */
    long int hlen;
    long int datalen;
} WAVdata;

/* ̵ǡ */
#define WAV8NULL (0x7f)
#define WAV16NULL (0xfff8)
/* WAVSCALE*bit: |粻|
 * WAVPOS*bit: linear data shift 
 */
#define WAVPOS8bit 127
#define WAVSCALE8bit 125.0
#define WAVPOS16bit 0
#define WAVSCALE16bit 32764.0

#define WAVMAXChannel 50

/* for chWAVheaderMASK */
#define WAV_FMCODE 	0x0002
#define WAV_CHANNEL 	0x0004
#define WAV_SMPLRATE 	0x0008
#define WAV_BLOCKSIZE	0x0010
#define WAV_BITPERSMPL	0x0020
#define WAV_BYTEPERSEC	0x0040

#ifdef __WAVIO_C__
# define EXTERN_WAVIO 
#else
# define EXTERN_WAVIO extern 
#endif

EXTERN_WAVIO int getWAVheaderchunk(FILE *file, WAVdata *wd, Chunk *Ch,
				   int mode);
#if 0
EXTERN_WAVIO int getWAVheader(FILE *file, WAVdata *wd);
EXTERN_WAVIO int getWAVheader_noseek(FILE *file, WAVdata *wd);
EXTERN_WAVIO int getWAVheader_noseek2(FILE *file, WAVdata *wd);
#endif
EXTERN_WAVIO void WAVmyfseek(FILE *file, int num);
#if 0
EXTERN_WAVIO int getWAVinfo(FILE *file, WAVdata *wd, Chunk *Ch);
#endif
EXTERN_WAVIO int chWAVheader(WAVdata *wd1, WAVdata *wd2);
EXTERN_WAVIO int chWAVheaderMASK(WAVdata *wd1, WAVdata *wd2, int mask);
EXTERN_WAVIO void putWAVheader(FILE *file, WAVdata *wd);

#endif /* __WAVIO_H__ */
